/*  xAngle - xa-002: Scratch
 *  Copyright (C) Joakim Kolsj, Johan Larsson, Anders Asplund 2003
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef GFX_LEDBOARD
#define GFX_LEDBOARD

#include "../basecode/surface.h"
#include "../basecode/global.h"

namespace demo
{
	namespace gfx
	{
		struct vline {
			bool *pix;
		};
		
		class ledboard
		{
		public:
			ledboard(surface *surface);
			void draw(pixel *p, int x, int y);
			void set(int x, int y, bool status);
			void draw_dot(pixel *p, int x, int y, bool status);
		private:
			demo::surface *s;
			vline *map;
			int width, height;
		};
	}
}

#endif
